#!/usr/bin/env python
# -*- coding:utf-8 -*-
# Author: qicongsheng
import glob
import os
import shutil
from pathlib import Path


def copy_matching_files(src_folder, dst_folder, patterns):
    Path(dst_folder).mkdir(parents=True, exist_ok=True)
    for pattern in patterns:
        matches = glob.glob(os.path.join(src_folder, pattern), recursive=True)
        for match in matches:
            name = os.path.basename(match)
            dst_path = os.path.join(dst_folder, name)
            if os.path.isdir(match):
                if not os.path.exists(dst_path):
                    shutil.copytree(match, dst_path)
                    print(f"复制文件夹: {match} -> {dst_path}")
                else:
                    print(f"文件夹已存在，跳过: {dst_path}")
            elif os.path.isfile(match):
                shutil.copy2(match, dst_path)
                print(f"复制文件: {match} -> {dst_path}")
            else:
                print(f"跳过非文件/文件夹: {match}")


def delete_matching_files(dst_folder, patterns):
    Path(dst_folder).mkdir(parents=True, exist_ok=True)
    for pattern in patterns:
        matches = glob.glob(os.path.join(dst_folder, pattern), recursive=True)
        for match in matches:
            name = os.path.basename(match)
            dst_path = os.path.join(dst_folder, name)
            if os.path.isdir(match):
                print(f"Deleting folder: {dst_path}")
                shutil.rmtree(dst_path)  # 删除文件夹
            elif os.path.isfile(match):
                print(f"Deleting file: {dst_path}")
                os.remove(dst_path)  # 删除文件
            else:
                print(f"跳过非文件/文件夹: {match}")
